;;; emacs-jdee-addons-site-start.el --- Startup script for JDEE addons

;; Copyright (C) 2004  Free Software Foundation, Inc.

;; Author: Alex Ott <ottalex@narod.ru>

(add-to-list 'load-path "/usr/share/emacs/site-lisp/jdee-addons")

(autoload 'javahelp-search "javahelp" "Open help for Java" t nil)
(autoload 'flymake-goto-prev-error "jde-flymake" "JDEE Flymake prev error" t nil)
(autoload 'flymake-goto-next-error "jde-flymake" "JDEE Flymake next error" t nil)
(autoload ''flymake-save-as-kill-err-messages-for-current-line "jde-flymake"
  "JDEE Flymake kill error messages" t nil)

(add-hook 'java-mode-hook
	  #'(lambda ()
				(require 'decompile)
	      (require 'jde-guess)
	      (require 'jde-introspect)
	      (require 'jde-jalopy)
	      (require 'jde-javadoc-pretty)
	      (require 'jde-jode)
	      (require 'jde-properties)
	      (require 'jde-stack)
	      (require 'jmaker)
	      (require 'jjar)
	      (require 'jsee)
	      (require 'jserial)
	      (require 'jtags)
	      (local-set-key [f12]   'javahelp-search)
	      (local-set-key [M-f7]  'flymake-goto-prev-error)
	      (local-set-key [M-f8]  'flymake-goto-next-error)
	      (local-set-key [M-f12]
			     'flymake-save-as-kill-err-messages-for-current-line)
	      ))

;; For jess-mode
(autoload 'jess-mode "jess-mode" "Jess Editing Mode" t nil)
(autoload 'run-jess "inf-jess" "Inferior Jess Mode" t nil)

(add-hook 'jess-mode-hook
          #'(lambda ()
              (auto-fill-mode t)
              (turn-on-font-lock)))

(setq auto-mode-alist
			(append auto-mode-alist '(("\\.clp$" . jess-mode))))


;;; emacs-jdee-addons-site-start.el ends here
