
;;go through and document everything necessary to 



(require 'jde-guess)

;;misc notes for Java refactoring...

(defun jde-refactor-package(base-directory from-package to-package)
  "This function tries to change the Java package name and should make all
necessary changed to your files so that your application will correctly
recompile.

The following operations are performed:

  - prompt for the directory which contains the package to refactor

  - what do you want to new package to be

  - move files into the new package directory

  - change all package statements in these files
  
  - go through all files and change their import statements.

  - close any buffers that are currently open which were just refactored. 
 
NOTE: this probably won't work on classes that are loaded dynamically via
Class.forName(). "

  (interactive
   (jde-refactor-package-guess-params))

  
)  

  
(defun jde-refactor-package-guess-params()
  "Try to guess param for function `jde-refactor-package' based on the current
situation.  If the buffer currently open is a java open we can guess some
information from it."

  (let(base-directory from-package to-package)
    (if (equal major-mode
               'jde-mode)

        (progn
          (setq base-directory (jde-guess-base-directory))))

    (setq from-package (read-string "Rename from: " from-package))

    ;;use the default of from-package this way 
    (setq to-package (read-string "Rename package to: " from-package))

    (list base-directory from-package to-package)))
                        
